pred show {}
run  show for 10

abstract sig clafer {parent : one clafer}
abstract sig string extends clafer {val : Int}
abstract sig integer extends clafer {val : Int}
fun children(p : clafer) : set clafer{p.~parent - p}

abstract sig ModelBase extends clafer
{ voidT : lone ModelBase_voidT
, stringT : lone ModelBase_stringT
, intT : lone ModelBase_intT
, boolT : lone ModelBase_boolT
, allClasses : set ModelBase_allClasses
, allInterfaces : set ModelBase_allInterfaces
, allAssociations : set ModelBase_allAssociations }
{}
sig absModelBase extends ModelBase {} { no absModelBase }
sig ModelBase_voidT extends VoidType
{}
{ parent = (ModelBase <: voidT).this }
sig ModelBase_stringT extends StringType
{}
{ parent = (ModelBase <: stringT).this }
sig ModelBase_intT extends IntegerType
{}
{ parent = (ModelBase <: intT).this }
sig ModelBase_boolT extends BooleanType
{}
{ parent = (ModelBase <: boolT).this }
sig ModelBase_allClasses extends Class
{}
{ parent = (ModelBase <: allClasses).this }
sig ModelBase_allInterfaces extends Interface
{}
{ parent = (ModelBase <: allInterfaces).this }
sig ModelBase_allAssociations extends Association
{}
{ parent = (ModelBase <: allAssociations).this }
abstract sig VoidType extends DataType
{}
{ (((@VoidType).(@name)).(@val)) = (0) }
sig absVoidType extends VoidType {} { no absVoidType }
abstract sig IntegerType extends DataType
{}
{ (((@IntegerType).(@name)).(@val)) = (1) }
sig absIntegerType extends IntegerType {} { no absIntegerType }
abstract sig StringType extends DataType
{}
{ (((@StringType).(@name)).(@val)) = (2) }
sig absStringType extends StringType {} { no absStringType }
abstract sig BooleanType extends DataType
{}
{ (((@BooleanType).(@name)).(@val)) = (3) }
sig absBooleanType extends BooleanType {} { no absBooleanType }
abstract sig Class extends Classifier
{ interfaces : set clafer
, associations : set clafer }
{ interfaces in @Interface
  all  i : (@Class).(@interfaces) | ((this)) in (((i).(@implementedBy)))
  all disj a1, a2 : (@Class).(@attributes) | (((a1).(@name)).(@val)) != (((a2).(@name)).(@val))
  associations in @AssociationEnd }
sig absClass extends Class {} { no absClass }
abstract sig Attribute extends NamedElement
{ multiplicity : one Attribute_multiplicity
, type : one clafer
, owner : one clafer }
{ type in @Type
  owner in @Classifier
  ((this)) in ((((@Attribute).(@owner)).(@attributes))) }
sig absAttribute extends Attribute {} { no absAttribute }
sig Attribute_multiplicity extends EInt
{}
{ parent = (Attribute <: multiplicity).this }
abstract sig Method extends NamedElement
{ paramNames : set Method_paramNames
, returnType : one clafer
, paramTypes : set clafer
, owner : one clafer }
{ (#(paramNames)) = (#(paramTypes))
  returnType in @Type
  paramTypes in @Type
  owner in @Classifier
  ((this)) in ((((@Method).(@owner)).(@methods))) }
sig absMethod extends Method {} { no absMethod }
sig Method_paramNames extends EString
{}
{ parent = (Method <: paramNames).this }
abstract sig Interface extends Classifier
{ implementedBy : set clafer }
{ implementedBy in @Class
  all  c : (@Interface).(@implementedBy) | ((this)) in (((c).(@interfaces)))
  no (@Interface).(@attributes) }
sig absInterface extends Interface {} { no absInterface }
abstract sig AssociationEnd extends NamedElement
{ lowerBound : one AssociationEnd_lowerBound
, upperBound : one AssociationEnd_upperBound
, class : one clafer
, association : one clafer }
{ class in @Class
  association in @Association }
sig absAssociationEnd extends AssociationEnd {} { no absAssociationEnd }
sig AssociationEnd_lowerBound extends EInt
{}
{ parent = (AssociationEnd <: lowerBound).this }
sig AssociationEnd_upperBound extends EInt
{}
{ parent = (AssociationEnd <: upperBound).this }
abstract sig Association extends NamedElement
{ ends : set Association_ends }
{ 2 <= #ends and #ends <= 2 }
sig absAssociation extends Association {} { no absAssociation }
sig Association_ends extends AssociationEnd
{}
{ parent = (Association <: ends).this }
abstract sig EString extends string
{}
{}
sig absEString extends EString {} { no absEString }
abstract sig EInt extends integer
{}
{}
sig absEInt extends EInt {} { no absEInt }
abstract sig DataType extends Type
{}
{}
sig absDataType extends DataType {} { no absDataType }
abstract sig Classifier extends Type
{ attributes : set Classifier_attributes
, methods : set Classifier_methods }
{}
sig absClassifier extends Classifier {} { no absClassifier }
sig Classifier_attributes extends Attribute
{}
{ parent = (Classifier <: attributes).this
  ((this).(@owner)) = (parent) }
sig Classifier_methods extends Method
{}
{ parent = (Classifier <: methods).this
  ((this).(@owner)) = (parent) }
abstract sig Type extends NamedElement
{}
{}
sig absType extends Type {} { no absType }
abstract sig NamedElement extends clafer
{ name : lone NamedElement_name }
{}
sig absNamedElement extends NamedElement {} { no absNamedElement }
sig NamedElement_name extends EString
{}
{ parent = (NamedElement <: name).this }
fact { all disj t1, t2 : @Type | (((t1).(@name)).(@val)) != (((t2).(@name)).(@val)) }
sig MyIntegerType extends IntegerType
{}
{ parent = this }
sig MyInterface extends Interface
{}
{ parent = this
  no (@MyInterface).(@implementedBy)
  ((((@MyInterface).(@attributes)).(@multiplicity)).(@val)) = (1) (((@MyInterface).(@attributes)).(@type)) = (@MyIntegerType) }
fact {  one MyIntegerType }
fact {  one MyInterface }

