pred show {}
run  show for 8

abstract sig integer{ val : Int}
abstract sig string{ val : Int}

abstract sig Class extends Classifier
{ interfaces : set @Interface
, associations : set @AssociationEnd }
{ all  i : (@Class).(@interfaces) | (this) in ((i).(@implementedBy))
  all disj a1, a2 : (@Class).(@attributes) | (((a1).(@name)).(@val)) != (((a2).(@name)).(@val)) }
abstract sig Attribute extends NamedElement
{ multiplicity : one Attribute_multiplicity
, type : one @Type
, owner : one @Classifier }
{ (this) in (((@Attribute).(@owner)).(@attributes)) }
sig Attribute_multiplicity extends EInt
{ parent : one Attribute }
{ parent = (Attribute <: multiplicity).this}
abstract sig Method extends NamedElement
{ paramNames : set Method_paramNames
, returnType : one @Type
, paramTypes : set @Type
, owner : one @Classifier }
{ (#(paramNames)) = (#(paramTypes))
  (this) in (((@Method).(@owner)).(@methods)) }
sig Method_paramNames extends EString
{ parent : one Method }
{ parent = (Method <: paramNames).this}
abstract sig Interface extends Classifier
{ implementedBy : set @Class }
{ all  c : (@Interface).(@implementedBy) | (this) in ((c).(@interfaces))
  no (@Interface).(@attributes) }
abstract sig AssociationEnd extends NamedElement
{ lowerBound : one AssociationEnd_lowerBound
, upperBound : one AssociationEnd_upperBound
, class : one @Class
, association : one @Association }
{}
sig AssociationEnd_lowerBound extends EInt
{ parent : one AssociationEnd }
{ parent = (AssociationEnd <: lowerBound).this}
sig AssociationEnd_upperBound extends EInt
{ parent : one AssociationEnd }
{ parent = (AssociationEnd <: upperBound).this}
abstract sig Association extends NamedElement
{ ends : set Association_ends }
{ 2 <= #ends and #ends <= 2 }
sig Association_ends extends AssociationEnd
{ parent : one Association }
{ parent = (Association <: ends).this}
abstract sig EString extends string
{}
{}
abstract sig EInt extends integer
{}
{}
abstract sig Classifier extends Type
{ attributes : set Classifier_attributes
, methods : set Classifier_methods }
{}
sig Classifier_attributes extends Attribute
{ parent : one Classifier }
{ parent = (Classifier <: attributes).this 
 (@owner) = (parent) }
sig Classifier_methods extends Method
{ parent : one Classifier }
{ parent = (Classifier <: methods).this 
 (@owner) = (parent) }
abstract sig Type extends NamedElement
{}
{}
abstract sig NamedElement
{ name : lone NamedElement_name }
{}
sig NamedElement_name extends EString
{ parent : one NamedElement }
{ parent = (NamedElement <: name).this}
fact { all disj t1, t2 : @Type | (((t1).(@name)).(@val)) != (((t2).(@name)).(@val)) }
sig iClass extends Class
{}
{}
sig iInterface extends Interface
{}
{}
sig iAssociationEnd extends AssociationEnd
{}
{}
sig iAssociation extends Association
{}
{}
fact { some @iClass some @iInterface some @iAssociationEnd some @iAssociation some (@Classifier).(@attributes) some (@Classifier).(@methods) some (@Method).(@paramNames) some (@NamedElement).(@name) }
